;:----------------- SFC-Box Charset Tool
;------------------
;  MB90082.BIN     9Kbytes  (Super Famicom Box OSD-Charset)     (MB90082-001)
;------------------
;assemble via TASM 5.0 or similar
;MCOM32.BAT
; @ echo off
; tasm32 /ml %1 %2 %3 %4 %5
; IF exist %1.RC     brcc32 %1 %2 %3 %4 %5
; IF exist %1.RC     tlink32 %1,%1,,,,%1 -x -Tpe -ap -V4.0
; IF NOT exist %1.RC tlink32 %1,%1,,,,   -x -Tpe -ap -V4.0
; del %1.obj
;------------------
.386
.model flat,STDCALL
.code
locals
includelib \talky\tasm32\import32.lib
extrn ExitProcess    :proc
extrn GetStdHandle   :proc
MB_OK                   equ 0
MB_ICONEXCLAMATION      equ 30h
STD_INPUT_HANDLE        equ -10
STD_OUTPUT_HANDLE       equ -11
MAX_PATH                equ 260
FILE_ATTRIBUTE_NORMAL   equ 080h
CREATE_ALWAYS           equ 2
OPEN_EXISTING           equ 3
GENERIC_READ            equ 80000000h
GENERIC_WRITE           equ 40000000h
FILE_SHARE_READ         equ 1h
GMEM_FIXED              equ 0
GMEM_ZEROINIT           equ 40h
extrn CreateFileA   :proc
extrn WriteFile     :proc
extrn GetFileSize   :proc
extrn ReadFile      :proc
extrn CloseHandle   :proc
extrn GlobalAlloc   :proc
extrn GlobalFree    :proc
;------------------
;:----------------- Data
;------------------
.data
;---
align 4
 std_out        dd 0
 diskresult     dd 0
;---
 align 4
 curr_pix_xloc    dd 0
 curr_pix_yloc    dd 0
 curr_page_xbase  dd 0
 curr_page_ybase  dd 0
 curr_page_number dd 0
 pixelized_pix_xloc dd 0
 pixelized_pix_yloc dd 0
 summary_pix_xloc   dd 0
 summary_pix_yloc   dd 0
 average_sum        dd 0
 average_sum_units  dd 0
 invert_mask        dd 0
 unclear_pixel_error_count dd 0
 dupe_char_error_counter   dd 0
 wrchr_buf    db 0
;---
fname_original_bitmap:
 db 'MB90082_original_screenshot.bmp',0  ;5,005,966 bytes (722x2309 pix at 24bpp) (aka 4 pages of 720x576 pix with 1-pix border)
;---
fname_gridded_bitmap:
 db 'MB90082_gridded.bmp',0              ;5,005,966 bytes (722x2309 pix at 24bpp) (aka 4 pages of 720x576 pix with 1-pix border)
;---
fname_pixelized_bitmap:
 db 'MB90082_pixelized.bmp',0
;---
fname_summary_bitmap:
 db 'MB90082_summary.bmp',0
;---
fname_binary_font:
 db 'MB90082.BIN',0
;---
txt_hello:
 db 'SFC-Box-Ch - Super Famicom Box charset tool 2013 nocash',0dh,0ah
 db 'Extracting SFC-Box OSD Charset from screenshot file...',0dh,0ah
 db 0
txt_missing             db 'ERROR: Missing source file',0
txt_write_error         db 'ERROR: Write Error',0
txt_conversion_error    db 'ERROR: Conversion error',0
txt_okay                db 'Okay.',0
;---
pixelized_bitmap_header:
 db 'BM'
 dd pixelized_bitmap_filesize
 dd 0
 dd 36h ;header size?
 dd 28h ;?
 dd pixelized_bitmap_xsiz_pix
 dd pixelized_bitmap_ysiz_pix
 dw 1
 dw 18h ;bpp?
 dd 0
 dd pixelized_bitmap_filesize-36h
 dd 0ec4h,0ec4h
 dd 0,0
ERRIF ($-pixelized_bitmap_header) NE 36h
;---
summary_bitmap_header:
 db 'BM'
 dd summary_bitmap_filesize
 dd 0
 dd 36h ;header size?
 dd 28h ;?
 dd summary_bitmap_xsiz_pix
 dd summary_bitmap_ysiz_pix
 dw 1
 dw 18h ;bpp?
 dd 0
 dd summary_bitmap_filesize-36h
 dd 0ec4h,0ec4h
 dd 0,0
ERRIF ($-summary_bitmap_header) NE 36h
;---
.code
;------------------
.data?
;---
with_greenish_logging equ 0  ;<-- optionally indicate which pixels were examined
origin_xloc equ 103  ;\upper-left corner of first source pixel
origin_yloc equ 89   ;/
last_xloc equ 569    ;-end of last pix
char_xpix equ 12        ;\pixels per character
char_ypix equ 18        ;/
num_chars_x equ 12      ;\num chars per page
num_chars_y equ 6       ;/
num_pages equ 4         ;-num pages
per_page_ystep equ 577  ;-num scanlines per page
fraction_x_bits equ 16
fraction_x_fac  equ (1 shl fraction_x_bits)
pix_xstep equ (((last_xloc-origin_xloc) shl fraction_x_bits)/(num_chars_x*char_xpix))
pix_ystep equ 4
;---
original_bitmap_xsiz_pix   equ 722
original_bitmap_ysiz_pix   equ 2309
original_bitmap_xsiz_bytes equ ((722*3+3) AND (not 3))
original_bitmap_filesize equ 36h+original_bitmap_xsiz_bytes*original_bitmap_ysiz_pix
ERRIF original_bitmap_filesize NE 5005966  ;5MB
;---
pixelized_bitmap_xsiz_pix equ num_chars_x*char_xpix
pixelized_bitmap_ysiz_pix equ num_chars_y*char_ypix*num_pages
pixelized_bitmap_xsiz_bytes equ pixelized_bitmap_xsiz_pix*3
pixelized_bitmap_filesize equ 36h+pixelized_bitmap_xsiz_bytes*pixelized_bitmap_ysiz_pix
;---
summary_bitmap_xsiz_pix   equ (16*char_xpix+17*2)
summary_bitmap_ysiz_pix   equ (16*char_ypix+17*2)
summary_bitmap_xsiz_bytes equ ((summary_bitmap_xsiz_pix*3+3) AND (not 3))
summary_bitmap_filesize equ 36h+summary_bitmap_xsiz_bytes*summary_bitmap_ysiz_pix
;---
;average original colors:
; FFFFFFh  White 1-pixel border (drawn around the 720x576 pix pages)
; 101010h  Black Screen Border
; 901018h  Blue Background
; 181818h  Black Text Pixels
; A8A8A8h  White Text Pixels
black_boundary       equ 018h+30h
white_boundary       equ 0a8h-30h
boundary_adjust_up   equ +30h
boundary_adjust_down equ -20h
;---
original_bitmap_buf:                                            ;\
 db 36h dup (?)   ;.BMP header                                  ; original
original_bitmap_body:                                           ; bitmap
 db original_bitmap_xsiz_bytes*original_bitmap_ysiz_pix dup (?) ;/
;---
gridded_bitmap_buf:                                             ;\
 db 36h dup (?)   ;.BMP header                                  ; gridded
gridded_bitmap_body:                                            ; bitmap
 db original_bitmap_xsiz_bytes*original_bitmap_ysiz_pix dup (?) ;/
;---
summary_bitmap_buf:                                             ;\
 db 36h dup (?)   ;.BMP header                                  ; summary
summary_bitmap_body:                                            ; bitmap
 db summary_bitmap_xsiz_bytes*summary_bitmap_ysiz_pix dup (?)   ;/
;---
pixelized_bitmap_buf:                                             ;\
 db 36h dup (?)   ;.BMP header                                    ; pixelized
pixelized_bitmap_body:                                            ; bitmap
 db pixelized_bitmap_xsiz_bytes*pixelized_bitmap_ysiz_pix dup (?) ;/
;---
font_pages db 18*2*48h*4 dup (?)    ;four pages of 48h chars (with dupes)
font_raw   db 18*2*100h  dup (?)    ;raw 100h chars (excluding dupes)
font_raw_filesize equ 18*2*100h
;---
.code
;------------------
;:----------------- Standalone Video I/O
;------------------
wrchr:
 pusha
 mov  byte ptr [wrchr_buf],al
 push 0                    ;set to 0 in most cases
 push offset diskresult    ;pointer to number of read bytes
 push 1                         ;length
 push offset wrchr_buf          ;source
 push dword ptr ds:[std_out]    ;handle
 call WriteFile
 popa
 ret
;------------------
wrstr_edx:
@@lop:
 mov  al,byte ptr [edx]
 inc  edx
 cmp  al,00h
 jz   short @@done
 call wrchr
 jmp  short @@lop
@@done:
 ret
;------------------
skipstr_esi:
@@lop:
 lodsb
 cmp  al,00h
 jnz  short @@lop
 ret
;------------------
wrspc:
 push eax
 mov  al,20h
 call wrchr
 pop  eax
 ret
;------------------
wrcrlf:
 push eax
 mov  al,0dh
 call wrchr
 mov  al,0ah
 call wrchr
 pop  eax
 ret
;------------------
wr_decimal_al:  ;supports only 2 digits (00..99)
 pusha
 mov  ah,0
 mov  dl,10
 div  dl
 or   ax,3030h
 call wrchr
 mov  al,ah ;remainder
 call wrchr
 popa
 ret
;------------------
wrdigital:
 push eax
 and  al,0fh
 cmp  al,09h
 jbe  short @@this
 add  al,07h
@@this:
 add  al,30h
 call wrchr
 pop  eax
 ret
;------------------
wrhexal:
 ror  al,4
 call wrdigital
 ror  al,4
 jmp  wrdigital
;------------------
;:----------------- File I/O and Memory Allocation
;------------------
freemem_edi:
 or   edi,edi
 jz   short @@none
 push edi  ;memory handle
 call GlobalFree
 xor  edi,edi ;now mark none allocated
@@none:
 ret
;------------------
load_file:       ;in: esi=filename, edi=addr, ebp=size
 push 0       ;for Win95 always 0       ;\
 push FILE_ATTRIBUTE_NORMAL             ;
 push OPEN_EXISTING                     ;
 push 0       ;no Security-attributes   ;
 push FILE_SHARE_READ                   ; open source file
 push GENERIC_READ   ;readaccess only   ;
 push esi            ;filename          ;
 call CreateFileA                       ;
 mov  ebx,eax        ;filehandle        ;
 inc  eax            ;FFFFFFFFh -> zf=1 ;
 jz   short @@fail                      ;/
 push 0 ;set to 0 in most cases         ;\
 push offset diskresult  ;ptr to result ;
 push ebp  ;filesize                    ; read file to memory
 push edi  ;memory handle (dest)        ;
 push ebx  ;filehandle                  ;
 call ReadFile                          ;/
 push ebx  ;filehandle                  ;\close file
 call CloseHandle                       ;/
 clc    ;cy=0=okay
 ret
;---
@@fail:
 mov  edx,offset txt_missing
 stc    ;cy=1=fail
 ret
;------------------
save_file:       ;in: esi=filename, edi=addr, ebp=size
 push 0                                  ;for Win95 always 0
 push FILE_ATTRIBUTE_NORMAL              ;standard Fileattributes
 push CREATE_ALWAYS                      ;create, overwrite existing
 push 0                                  ;no Security-attributes
 push 0                                  ;disable Share-Mode
 push GENERIC_READ + GENERIC_WRITE       ;read- and writeaccess
 push esi                                ;file name
 call CreateFileA                        ;open file
 mov  ebx,eax                            ;fhandle
 inc  eax            ;FFFFFFFFh -> zf=1
 jz   short @@fail
 ;---save original size
 push 0                    ;set to 0 in most cases
 push offset diskresult    ;pointer to result
 push ebp                  ;length (filesize)
 push edi                  ;address (src)
 push ebx                  ;file handle
 call WriteFile
 or   eax,eax
 jz   short @@fail
 cmp  dword ptr [diskresult],ebp
 jne  short @@fail
 ;---close
 push ebx                  ;file handle
 call CloseHandle
 clc    ;cy=0=okay
 ret
;---
@@fail:
 mov  edx,offset txt_write_error
 stc    ;cy=1=fail
 ret
;------------------
;:----------------- Bitmap stuff
;------------------
draw_pix_eax_to_edi:       ;draw 24bpp (aka 3 bytes)
 mov  byte ptr [edi+0],al
 ror  eax,8
 mov  byte ptr [edi+1],al
 ror  eax,8
 mov  byte ptr [edi+2],al
 rol  eax,16 ;undo
 ret
;------------------
get_pix_addr_edi:
 push eax
 mov  edi,dword ptr [curr_pix_xloc]
 shr  edi,fraction_x_bits
 mov  eax,original_bitmap_ysiz_pix-1
 sub  eax,dword ptr [curr_pix_yloc]
 imul eax,original_bitmap_xsiz_bytes  ;yloc*xsiz_bytes
 lea  edi,[edi*2+edi]                 ;xloc*3
 add  edi,eax
 pop  eax
 ret
;------------------
get_pixelized_pix_addr_edi:
 push eax
 mov  edi,dword ptr [pixelized_pix_xloc]
 mov  eax,pixelized_bitmap_ysiz_pix-1
 sub  eax,dword ptr [pixelized_pix_yloc]
 imul eax,pixelized_bitmap_xsiz_bytes  ;yloc*xsiz_bytes
 lea  edi,[edi*2+edi]                  ;xloc*3
 lea  edi,[edi+eax+pixelized_bitmap_body]
 pop  eax
 ret
;------------------
get_summary_pix_addr_edi:
 push eax
 mov  edi,dword ptr [summary_pix_xloc]
 mov  eax,summary_bitmap_ysiz_pix-1
 sub  eax,dword ptr [summary_pix_yloc]
 imul eax,summary_bitmap_xsiz_bytes  ;yloc*xsiz_bytes
 lea  edi,[edi*2+edi]                ;xloc*3
 lea  edi,[edi+eax+summary_bitmap_body]
 pop  eax
 ret
;------------------
draw_pix_grid:
 mov  eax,dword ptr [curr_page_ybase]           ;\
 mov  dword ptr [curr_pix_yloc],eax             ; lop y ...
 mov  ecx,num_chars_y*char_ypix+1               ;
@@ylop:                                         ;
 push ecx                                       ;/
 mov  eax,dword ptr [curr_page_xbase]           ;\
 mov  dword ptr [curr_pix_xloc],eax             ; lop x ...
 mov  ecx,num_chars_x*char_xpix+1               ;
@@xlop:                                         ;/
 call get_pix_addr_edi                          ;\
 add  edi,offset gridded_bitmap_body            ; draw grid
 mov  eax,0ff0000h                              ;
 call draw_pix_eax_to_edi                       ;/
 add  dword ptr [curr_pix_xloc],pix_xstep       ;\next x
 loop short @@xlop                              ;/
 add  dword ptr [curr_pix_yloc],pix_ystep       ;\
 pop  ecx                                       ; next y
 loop short @@ylop                              ;/
 ret
;------------------
get_average_pixel_color:
 mov  dword ptr [average_sum],0                 ;\init sum
 mov  dword ptr [average_sum_units],0           ;/
 push dword ptr [curr_pix_yloc]
 mov  ecx,3                                     ;\lop y...
@@ylop:                                         ;
 inc  dword ptr [curr_pix_yloc]                 ;/
 push ecx
 push dword ptr [curr_pix_xloc]
 mov  ecx,3                                     ;\lop x...
@@xlop:                                         ;
 add  dword ptr [curr_pix_xloc],pix_xstep/4     ;/
 call get_pix_addr_edi                          ;\
 IF with_greenish_logging                       ;  ;\indicate which pixels
   or   byte ptr [edi+gridded_bitmap_body+1],40h;  ; have been examined
 ENDIF                                          ;  ;/(by greenish shade)
 add  edi,offset original_bitmap_body           ;
 REPT 3  ;R,G,B                                 ;
   movzx eax,byte ptr [edi]                     ; sum-up
   inc  edi                                     ;
   add  dword ptr [average_sum],eax             ;
   inc  dword ptr [average_sum_units]           ;
 ENDM                                           ;/
 loop short @@xlop                              ;-next x
 pop  dword ptr [curr_pix_xloc]                 ;\
 pop  ecx                                       ; next y
 loop short @@ylop                              ;/
 pop  dword ptr [curr_pix_yloc]
 mov  eax,dword ptr [average_sum]               ;\
 xor  edx,edx                                   ; calc result
 div  dword ptr [average_sum_units]             ;/
 ret
;------------------
analyze_pixel_color:  ;in: eax, out: cy,zf,edx
 cmp  eax,black_boundary   ;\
 mov  edx,0000000h  ;black ; clear dark
 jl   short @@this_color   ;/
 cmp  eax,white_boundary   ;\
 mov  edx,0ffffffh  ;white ; clear white
 jg   short @@this_color   ;/
 mov  edx,0ff0000h  ;red
 stc           ;cy=1=unclear
 ret
;---
@@this_color:
 or   edx,edx  ;cy=0=clear, and z=black/nz=white
 ret
;------------------
create_pixelized_bitmap:
 mov  eax,dword ptr [curr_page_ybase]           ;\
 mov  dword ptr [curr_pix_yloc],eax             ; lop y ...
 mov  ecx,num_chars_y*char_ypix                 ;
@@ylop:                                         ;
 push ecx                                       ;/
 mov  eax,dword ptr [curr_page_xbase]           ;\
 mov  dword ptr [curr_pix_xloc],eax             ; lop x ...
 mov  dword ptr [pixelized_pix_xloc],0          ;
 mov  ecx,num_chars_x*char_xpix                 ;
@@xlop:                                         ;
 push ecx                                       ;/
 call get_average_pixel_color                   ;\
 call analyze_pixel_color                       ; try to identify curr pixel
 jnc  short @@this  ;clearly defined            ;/
 mov  edx,-pix_xstep                            ;\
 call @@adjust_by_side_pixel                    ; adjust in respect to
 mov  edx,+pix_xstep                            ; left+right pixels
 call @@adjust_by_side_pixel                    ;/
 call analyze_pixel_color                       ;\
 jnc  short @@this  ;clearly adjusted           ; analyse adjusted result
 inc  dword ptr [unclear_pixel_error_count]     ;/
@@this:
 mov  eax,edx  ;color
 call get_pixelized_pix_addr_edi
 call draw_pix_eax_to_edi

 add  dword ptr [curr_pix_xloc],pix_xstep       ;\
 inc  dword ptr [pixelized_pix_xloc]            ; next x
 pop  ecx                                       ;
 loop short @@xlop                              ;/
 add  dword ptr [curr_pix_yloc],pix_ystep       ;\
 inc  dword ptr [pixelized_pix_yloc]            ; next y
 pop  ecx                                       ;
 loop short @@ylop                              ;/
 ret
;---
@@adjust_by_side_pixel:
 push dword ptr [curr_pix_xloc]
 add  dword ptr [curr_pix_xloc],edx ;+/-pix_xstep
 push eax
 call get_average_pixel_color
 call analyze_pixel_color
 pop  eax
 jc   short @@side_pixel_is_unclear_no_adjust
 mov  edx,boundary_adjust_up       ;\for BLACK SIDE pixel --> RAISE MID pixel
 jz   short @@adjust_so            ;/
 mov  edx,boundary_adjust_down     ;\for WHITE SIDE pixel --> DIM MID pixel
@@adjust_so:                       ;/
 add  eax,edx    ;<-- adjust
@@side_pixel_is_unclear_no_adjust:
 pop  dword ptr [curr_pix_xloc]
 ret
;------------------
make_paged_font:
 mov  ebp,offset font_pages     ;dest
 mov  dword ptr [invert_mask],000000h           ;-
 mov  dword ptr [pixelized_pix_yloc],0          ;\
 mov  ecx,num_chars_y*num_pages                 ; lop y...
@@char_ylop:                                    ;
 push ecx                                       ;/
 mov  dword ptr [pixelized_pix_xloc],0          ;\
 mov  ecx,num_chars_x                           ; lop x...
@@char_xlop:                                    ;
 push ecx                                       ;/
 call @@extract_char                            ;<--- extract char
 xor  dword ptr [invert_mask],0ffffffh          ;\
 add  dword ptr [pixelized_pix_xloc],char_xpix  ; next x
 pop  ecx                                       ;
 loop short @@char_xlop                         ;/
 xor  dword ptr [invert_mask],0ffffffh          ;\
 add  dword ptr [pixelized_pix_yloc],char_ypix  ; next y
 pop  ecx                                       ;
 loop short @@char_ylop                         ;/
 ret
;---
@@extract_char:
 push dword ptr [pixelized_pix_yloc]
 mov  ecx,char_ypix                             ;\
@@pix_ylop:                                     ; lop y...
 push ecx                                       ;/
 push dword ptr [pixelized_pix_xloc]
 mov  word ptr [ebp],0000h
 mov  ecx,char_xpix                             ;\
@@pix_xlop:                                     ; lop x...
 push ecx                                       ;/
 call get_pixelized_pix_addr_edi                ;\
 mov  al,byte ptr [edi]                         ;
 xor  al,byte ptr [invert_mask]                 ; binarize pixel
 shl  al,1                                      ;
 rcl  word ptr [ebp],1                          ;/
 inc  dword ptr [pixelized_pix_xloc]            ;\
 pop  ecx                                       ; next x
 loop short @@pix_xlop                          ;/
 add  ebp,2
 pop  dword ptr [pixelized_pix_xloc]
 inc  dword ptr [pixelized_pix_yloc]            ;\
 pop  ecx                                       ; next y
 loop short @@pix_ylop                          ;/
 pop  dword ptr [pixelized_pix_yloc]
 ret
;------------------
make_raw_font:
 mov  esi,offset font_pages  ;<-- four pages of 48h chars (with dupes)
 mov  edi,offset font_raw    ;<-- raw 100h chars (excluding dupes)
 mov  edx,num_pages
@@page_lop:
 mov  ecx,18*2*40h      ;\copy 40h chars
 rep  movsb             ;/
 add  esi,18*2*08h      ;-skip 08h dupe chars
 dec  edx
 jnz  short @@page_lop
 ret
;------------------
verify_dupe_chars:
 mov  esi,offset font_pages             ;begin of first page
 mov  edi,offset font_pages+18*2*48h*4  ;end of last page
 mov  edx,num_pages
@@page_lop:
 push esi
 sub  edi,18*2*8  ;stepback 8 chars
 mov  ecx,18*2*8                                ;\
 repe cmpsb                                     ;
 je   short @@okay                              ; verify 8 chars
 inc  dword ptr [dupe_char_error_counter]       ;
@@okay:                                         ;/
 pop  esi
 add  esi,18*2*48h   ;-begin of next page
 mov  edi,esi        ;-end of prev page
 dec  edx
 jnz  short @@page_lop
 ret
;------------------
create_summary_bitmap:
 mov  esi,offset font_raw                       ;-source
 mov  dword ptr [summary_pix_yloc],2            ;\
 mov  ecx,16                                    ; lop y...
@@char_ylop:                                    ;
 push ecx                                       ;/
 mov  dword ptr [summary_pix_xloc],2            ;\
 mov  ecx,16                                    ; lop x...
@@char_xlop:                                    ;
 push ecx                                       ;/
 call @@draw_char                               ;<--- draw char
 add  dword ptr [summary_pix_xloc],char_xpix+2  ;\
 pop  ecx                                       ; next x
 loop short @@char_xlop                         ;/
 add  dword ptr [summary_pix_yloc],char_ypix+2  ;\
 pop  ecx                                       ; next y
 loop short @@char_ylop                         ;/
 ret
;---
@@draw_char:
 push dword ptr [summary_pix_yloc]
 mov  ecx,char_ypix                             ;\
@@pix_ylop:                                     ; lop y...
 push ecx                                       ;/
 push dword ptr [summary_pix_xloc]
 mov  dx,word ptr [esi]
 add  esi,2
 shl  edx,32-char_xpix
 mov  ecx,char_xpix                             ;\
@@pix_xlop:                                     ; lop x...
 push ecx                                       ;/
 call get_summary_pix_addr_edi                  ;\
 xor  eax,eax      ;black                       ;
 shl  edx,1                                     ;
 jc   short @@this_pix                          ; draw pixel
 mov  eax,0ffffffh ;white                       ;
@@this_pix:                                     ;
 call draw_pix_eax_to_edi                       ;/
 inc  dword ptr [summary_pix_xloc]              ;\
 pop  ecx                                       ; next x
 loop short @@pix_xlop                          ;/
 pop  dword ptr [summary_pix_xloc]
 inc  dword ptr [summary_pix_yloc]              ;\
 pop  ecx                                       ; next y
 loop short @@pix_ylop                          ;/
 pop  dword ptr [summary_pix_yloc]
 ret
;------------------
;:----------------- Main
;------------------
start:
 push STD_OUTPUT_HANDLE         ;\
 call GetStdHandle              ;
 mov  dword ptr [std_out],eax   ;/
 mov  edx,offset txt_hello      ;\
 call wrstr_edx                 ;/
 ;- - -
 mov  esi,offset fname_original_bitmap  ;fname  ;\
 mov  edi,offset original_bitmap_buf    ;addr   ; load original bitmap
 mov  ebp,original_bitmap_filesize      ;size   ;
 call load_file                                 ;
 jc         @@fail                              ;/
 mov  esi,offset original_bitmap_buf            ;\
 mov  edi,offset gridded_bitmap_buf             ; copy original to gridded
 mov  ecx,original_bitmap_filesize              ; bitmap buffer
 rep  movsb                                     ;/
 mov  esi,offset pixelized_bitmap_header        ;\
 mov  edi,offset pixelized_bitmap_buf           ; copy header to uninitialized
 mov  ecx,36h                                   ; pixelized bitmap buffer
 rep  movsb                                     ;/
 mov  esi,offset summary_bitmap_header          ;\
 mov  edi,offset summary_bitmap_buf             ; copy header to uninitialized
 mov  ecx,36h                                   ; summary bitmap buffer
 rep  movsb                                     ;/
 mov  edi,offset summary_bitmap_body                            ;\
 mov  ecx,summary_bitmap_xsiz_bytes*summary_bitmap_ysiz_pix     ; init gray bg
 mov  al,80h                                                    ; of summary
 rep  stosb                                                     ;/
 mov  dword ptr [pixelized_pix_yloc],0          ;-
 ;---
 mov  dword ptr [curr_page_xbase],origin_xloc shl fraction_x_bits
 mov  dword ptr [curr_page_ybase],origin_yloc
 mov  dword ptr [curr_page_number],0
@@page_lop:
 call draw_pix_grid                             ;-
 call create_pixelized_bitmap                   ;-
 add  dword ptr [curr_page_ybase],per_page_ystep        ;\
 inc  dword ptr [curr_page_number]                      ; next page
 cmp  dword ptr [curr_page_number],num_pages            ;
 jb   short @@page_lop                                  ;/
 ;---
 call make_paged_font
 call make_raw_font
 call verify_dupe_chars
 call create_summary_bitmap
 ;---
 mov  esi,offset fname_gridded_bitmap   ;fname  ;\
 mov  edi,offset gridded_bitmap_buf     ;addr   ;
 mov  ebp,original_bitmap_filesize      ;size   ; save gridded bitmap
 call save_file                                 ;
 jc   short @@fail                              ;/
 mov  esi,offset fname_pixelized_bitmap ;fname  ;\
 mov  edi,offset pixelized_bitmap_buf   ;addr   ;
 mov  ebp,pixelized_bitmap_filesize     ;size   ; save pixelized bitmap
 call save_file                                 ;
 jc   short @@fail                              ;/
 mov  esi,offset fname_summary_bitmap   ;fname  ;\
 mov  edi,offset summary_bitmap_buf     ;addr   ;
 mov  ebp,summary_bitmap_filesize       ;size   ; save summary bitmap
 call save_file                                 ;
 jc   short @@fail                              ;/
 mov  esi,offset fname_binary_font      ;fname  ;\
 mov  edi,offset font_raw               ;addr   ;
 mov  ebp,font_raw_filesize             ;size   ; save binary font
 call save_file                                 ;
 jc   short @@fail                              ;/
 ;---
 mov  eax,dword ptr [unclear_pixel_error_count] ;\
 add  eax,dword ptr [dupe_char_error_counter]   ; check if any errors occurred
 mov  edx,offset txt_conversion_error           ;
 jnz  short @@fail                              ;/
 mov  edx,offset txt_okay                       ;-okay!
@@fail:
 call wrstr_edx  ;error name (or "OKAY")
 call wrcrlf
 ;- - -
 push 0  ;return value
 call ExitProcess               ;-terminate program
;------------------
end start
